VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "myprintset"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'ʾӡüҳöԻ
Private Const CCHDEVICENAME = 32
Private Const CCHFORMNAME = 32
Private Const GMEM_FIXED = &H0
Private Const GMEM_MOVEABLE = &H2
Private Const GMEM_ZEROINIT = &H40
Private Const DM_DUPLEX = &H1000&
Private Const DM_ORIENTATION = &H1&
Private Const DM_PAPERSIZE = &H2&
Private Const PSD_MARGINS = &H2
Private Const PSD_INHUNDREDTHSOFMILLIMETERS = &H8


Private Type PRINTDLG_TYPE
  lStructSize As Long
  hwndOwner As Long
  hDevMode As Long
  hDevNames As Long
  hdc As Long
  FLAGS As Long
  nFromPage As Integer
  nToPage As Integer
  nMinPage As Integer
  nMaxPage As Integer
  nCopies As Integer
  hInstance As Long
  lCustData As Long
  lpfnPrintHook As Long
  lpfnSetupHook As Long
  lpPrintTemplateName As String
  lpSetupTemplateName As String
  hPrintTemplate As Long
  hSetupTemplate As Long
End Type

Private Type DEVNAMES_TYPE
  wDriverOffset As Integer
  wDeviceOffset As Integer
  wOutputOffset As Integer
  wDefault As Integer
  extra As String * 100
End Type

Private Type DEVMODE_TYPE
  dmDeviceName As String * CCHDEVICENAME
  dmSpecVersion As Integer
  dmDriverVersion As Integer
  dmSize As Integer
  dmDriverExtra As Integer
  dmFields As Long
  dmOrientation As Integer
  dmPaperSize As Integer
  dmPaperLength As Integer
  dmPaperWidth As Integer
  dmScale As Integer
  dmCopies As Integer
  dmDefaultSource As Integer
  dmPrintQuality As Integer
  dmColor As Integer
  dmDuplex As Integer
  dmYResolution As Integer
  dmTTOption As Integer
  dmCollate As Integer
  dmFormName As String * CCHFORMNAME
  dmUnusedPadding As Integer
  dmBitsPerPel As Integer
  dmPelsWidth As Long
  dmPelsHeight As Long
  dmDisplayFlags As Long
  dmDisplayFrequency As Long
End Type

Private Declare Function PrintDialog Lib "comdlg32.dll" Alias "PrintDlgA" (pPrintdlg As PRINTDLG_TYPE) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
Private Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Public Enum PrinterConstants
  cdlPDAllPages = &H0
  cdlPDCollate = &H10
  cdlPDDisablePrintToFile = &H80000
  cdlPDHelpButton = &H800
  cdlPDHidePrintToFile = &H100000
  cdlPDNoPageNums = &H8
  cdlPDNoSelection = &H4
  cdlPDNoWarning = &H80
  cdlPDPageNums = &H2
  cdlPDPrintSetup = &H40
  cdlPDPrintToFile = &H20
  cdlPDReturnDC = &H100
  cdlPDReturnDefault = &H400
  cdlPDReturnIC = &H200
  cdlPDSelection = &H1
  cdlPDUseDevModeCopies = &H40000
End Enum
Public Enum ErrorConstants
  cdlCancel = 32755
End Enum
'
Private intMinPage As Integer  ' Сҳ
Private intMaxPage As Integer  ' ҳ
Private intFromPage As Integer ' һҳӡ
Private intToPage As Integer   ' һҳΪֹ


Public FLAGS As PrinterConstants
Public CancelError As Boolean

'Ϊҳ
Private Type Rect
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Type PageSetupDlg
    lStructSize As Long
    hwndOwner As Long
    hDevMode As Long
    hDevNames As Long
    FLAGS As Long
    ptPaperSize As POINTAPI
    rtMinMargin As Rect
    rtMargin As Rect
    hInstance As Long
    lCustData As Long
    lpfnPageSetupHook As Long
    lpfnPagePaintHook As Long
    lpPageSetupTemplateName As String
    hPageSetupTemplate As Long
End Type
Dim mymargin As Rect 'ʼͽҳúҳ߾,λΪ
Private Declare Function PageSetupDlg Lib "comdlg32.dll" Alias "PageSetupDlgA" (pPagesetupdlg As PageSetupDlg) As Long

Public Function ShowPageSet() As Boolean
'ʾҳöԻ
Dim DevMode As DEVMODE_TYPE
Dim DevName As DEVNAMES_TYPE
Dim lpDevMode As Long, lpDevName As Long
Dim intReturn As Integer
Dim objPrinter As Printer
Dim strNewPrinterName As String
Dim blnCancel   As Boolean
blnCancel = False
Dim PageSetup As PageSetupDlg
With PageSetup
    .lStructSize = Len(PageSetup)
    .hwndOwner = 0
    .FLAGS = PSD_MARGINS + PSD_INHUNDREDTHSOFMILLIMETERS 'ָʾҳ߾,ʹ1/100Ϊλ
    .rtMargin.Bottom = mymargin.Bottom * 100 'ɺ׵ĵλת
    .rtMargin.Top = mymargin.Top * 100
    .rtMargin.Left = mymargin.Left * 100
    .rtMargin.Right = mymargin.Right * 100

     DevMode.dmDeviceName = Printer.DeviceName
     DevMode.dmSize = Len(DevMode)
     DevMode.dmFields = DM_ORIENTATION Or DM_DUPLEX Or DM_PAPERSIZE 'ָʾʼֽŷ,ߴ
     DevMode.dmOrientation = Printer.Orientation
     DevMode.dmPaperSize = Printer.PaperSize
     On Error Resume Next
     DevMode.dmDuplex = Printer.Duplex
     On Error GoTo 0
    
     PageSetup.hDevMode = GlobalAlloc(GMEM_MOVEABLE Or _
                                  GMEM_ZEROINIT, Len(DevMode))
     lpDevMode = GlobalLock(PageSetup.hDevMode)
     If lpDevMode > 0 Then
        CopyMemory ByVal lpDevMode, DevMode, Len(DevMode)
        intReturn = GlobalUnlock(lpDevMode)
    End If
    With DevName
        .wDriverOffset = 8
        .wDeviceOffset = .wDriverOffset + 1 + Len(Printer.DriverName)
        .wOutputOffset = .wDeviceOffset + 1 + Len(Printer.Port)
        .wDefault = 0
    End With
    With Printer
        DevName.extra = .DriverName & Chr(0) & _
                    .DeviceName & Chr(0) & .Port & Chr(0)
    End With
    'ڴ
    PageSetup.hDevNames = GlobalAlloc(GMEM_MOVEABLE Or _
                                   GMEM_ZEROINIT, Len(DevName))
    lpDevName = GlobalLock(PageSetup.hDevNames)
    If lpDevName > 0 Then
        CopyMemory ByVal lpDevName, DevName, Len(DevName)
        intReturn = GlobalUnlock(lpDevName)
    End If
    If PageSetupDlg(PageSetup) = 0 Then
        'ȡ
        blnCancel = True
        ShowPageSet = False
         GlobalFree PageSetup.hDevMode
         GlobalFree PageSetup.hDevNames
        Exit Function
    End If
    mymargin.Left = .rtMargin.Left / 100 'תΪ
    mymargin.Right = .rtMargin.Right / 100
    mymargin.Top = .rtMargin.Top / 100
    mymargin.Bottom = .rtMargin.Bottom / 100
     'ȵõDevName ṹ
    lpDevName = GlobalLock(PageSetup.hDevNames)
    CopyMemory DevName, ByVal lpDevName, 45
    intReturn = GlobalUnlock(lpDevName)
    With PageSetup
      FLAGS = .FLAGS
    End With
     GlobalFree PageSetup.hDevNames
    'ȻõDevModeṹ
    lpDevMode = GlobalLock(PageSetup.hDevMode)
    CopyMemory DevMode, ByVal lpDevMode, Len(DevMode)
    intReturn = GlobalUnlock(PageSetup.hDevMode)
    GlobalFree PageSetup.hDevMode
    strNewPrinterName = UCase$(Left(DevMode.dmDeviceName, _
                        InStr(DevMode.dmDeviceName, Chr$(0)) - 1))
    'Ϊ,ԭstrNewPrinterNameֻ32λ,ӡƽϳ,᲻ȷ
    'ֻȡǰߵĳ
    'ע,ӡƴǰ32λͬ,ÿܲȷ
    Dim mylen As Integer
    mylen = LenB(StrConv(strNewPrinterName, vbFromUnicode)) 'ʵʳ
    If UCase$(StrConv(LeftB(StrConv(Printer.DeviceName, vbFromUnicode), mylen), vbUnicode)) <> strNewPrinterName Then
      For Each objPrinter In Printers
        If StrConv(LeftB(StrConv(UCase$(objPrinter.DeviceName), vbFromUnicode), mylen), vbUnicode) = strNewPrinterName Then _
          Set Printer = objPrinter
      Next
    End If
    On Error Resume Next

    With Printer
      .Copies = DevMode.dmCopies
      .Duplex = DevMode.dmDuplex
      .Orientation = DevMode.dmOrientation
      .PaperSize = DevMode.dmPaperSize 'ϵ,ֽŴС
    End With
End With
ShowPageSet = Not blnCancel
End Function

'
' -- INITIALIZE
'
Private Sub Class_Initialize()
  intMinPage = 0
  intMaxPage = 0
  intFromPage = 0
  intToPage = 0
  CancelError = False
End Sub
'
' -- PUBLIC MEMBERS
'
Property Get Min() As Integer
  Min = intMinPage
End Property
Property Get LeftMargin() As Single
  LeftMargin = mymargin.Left
End Property
Property Let LeftMargin(tt As Single)
  mymargin.Left = tt
End Property
Property Get RightMargin() As Single
  RightMargin = mymargin.Right
End Property
Property Let RightMargin(tt As Single)
  mymargin.Right = tt
End Property
Property Get TopMargin() As Single
  TopMargin = mymargin.Top
End Property
Property Let TopMargin(tt As Single)
  mymargin.Top = tt
End Property
Property Get BottomMargin() As Single
  BottomMargin = mymargin.Bottom
  'ҳ±߾
End Property
Property Let BottomMargin(tt As Single)
  mymargin.Bottom = tt
  'ҳʱĳʼҳ±߾,λΪ
End Property
Property Let Min(ByVal intNewValue As Integer)
  intNewValue = IIf(intNewValue > 0, intNewValue, 0)
  intMinPage = intNewValue
  If intNewValue > intFromPage Then _
    intFromPage = intNewValue
  If intNewValue > intToPage Then _
    intToPage = intNewValue
  If intNewValue > intMaxPage Then _
    intMaxPage = intNewValue
End Property
Property Get FromPage() As Integer
  FromPage = intFromPage
End Property
Property Let FromPage(ByVal intNewValue As Integer)
  intNewValue = IIf(intNewValue > 0, intNewValue, 0)
  intFromPage = intNewValue
  If intNewValue > intToPage Then _
    intToPage = intNewValue
  If intNewValue > intMaxPage Then _
    intMaxPage = intNewValue
  If intNewValue < intMinPage Then _
    intMinPage = intNewValue
End Property
Property Get ToPage() As Integer
  ToPage = intToPage
End Property
Property Let ToPage(ByVal intNewValue As Integer)
  intNewValue = IIf(intNewValue > 0, intNewValue, 0)
  intToPage = intNewValue
  If intNewValue > intMaxPage Then _
    intMaxPage = intNewValue
  If intNewValue < intFromPage Then _
    intFromPage = intNewValue
  If intNewValue < intMinPage Then _
    intMinPage = intNewValue
End Property
Property Get Max() As Integer
  Max = intMaxPage
End Property
Property Let Max(ByVal intNewValue As Integer)
  intNewValue = IIf(intNewValue > 0, intNewValue, 0)
  intMaxPage = intNewValue
  If intNewValue < intToPage Then _
    intToPage = intNewValue
  If intNewValue < intFromPage Then _
    intFromPage = intNewValue
  If intNewValue < intMinPage Then _
    intMinPage = intNewValue
End Property
Public Function ShowPrinter() As Boolean
Dim PrintDlg As PRINTDLG_TYPE
Dim DevMode As DEVMODE_TYPE
Dim DevName As DEVNAMES_TYPE
Dim lpDevMode As Long, lpDevName As Long
Dim intReturn As Integer
Dim objPrinter As Printer
Dim strNewPrinterName As String
Dim blnCancel   As Boolean
blnCancel = False
  With PrintDlg
    .lStructSize = Len(PrintDlg)
    .hwndOwner = 0
    .FLAGS = FLAGS
    .nMinPage = 1 'Сҳ
    .nFromPage = 1 'һҳ
    .nToPage = intMaxPage 'һҳ
    .nMaxPage = intMaxPage 'ҳ
  End With
  DevMode.dmDeviceName = Printer.DeviceName
  DevMode.dmSize = Len(DevMode)
  DevMode.dmFields = DM_ORIENTATION Or DM_DUPLEX Or DM_PAPERSIZE
  DevMode.dmOrientation = Printer.Orientation
  DevMode.dmPaperSize = Printer.PaperSize
  On Error Resume Next
  DevMode.dmDuplex = Printer.Duplex
  On Error GoTo 0
  PrintDlg.hDevMode = GlobalAlloc(GMEM_MOVEABLE Or _
                                  GMEM_ZEROINIT, Len(DevMode))
  lpDevMode = GlobalLock(PrintDlg.hDevMode)
  If lpDevMode > 0 Then
    CopyMemory ByVal lpDevMode, DevMode, Len(DevMode)
    intReturn = GlobalUnlock(lpDevMode)
  End If
  With DevName
    .wDriverOffset = 8
    .wDeviceOffset = .wDriverOffset + 1 + Len(Printer.DriverName)
    .wOutputOffset = .wDeviceOffset + 1 + Len(Printer.Port)
    .wDefault = 0
  End With
  With Printer
    DevName.extra = .DriverName & Chr(0) & _
                    .DeviceName & Chr(0) & .Port & Chr(0)
  End With
  PrintDlg.hDevNames = GlobalAlloc(GMEM_MOVEABLE Or _
                                   GMEM_ZEROINIT, Len(DevName))
  lpDevName = GlobalLock(PrintDlg.hDevNames)
  If lpDevName > 0 Then
    CopyMemory ByVal lpDevName, DevName, Len(DevName)
    intReturn = GlobalUnlock(lpDevName)
  End If

  If PrintDialog(PrintDlg) Then
    lpDevName = GlobalLock(PrintDlg.hDevNames)
    CopyMemory DevName, ByVal lpDevName, 45
    intReturn = GlobalUnlock(lpDevName)
    With PrintDlg
      FLAGS = .FLAGS
      intFromPage = .nFromPage
      intToPage = .nToPage
    End With
     GlobalFree PrintDlg.hDevNames
    lpDevMode = GlobalLock(PrintDlg.hDevMode)
    CopyMemory DevMode, ByVal lpDevMode, Len(DevMode)
    intReturn = GlobalUnlock(PrintDlg.hDevMode)
    GlobalFree PrintDlg.hDevMode
    strNewPrinterName = UCase$(Left(DevMode.dmDeviceName, _
                        InStr(DevMode.dmDeviceName, Chr$(0)) - 1))
    'Ϊ,ԭstrNewPrinterNameֻ32λ,ӡƽϳ,᲻ȷ
    'ֻȡǰߵĳ
    'ע,ӡƴǰ32λͬ,ÿܲȷ
    Dim mylen As Integer
    mylen = LenB(StrConv(strNewPrinterName, vbFromUnicode)) 'ʵʳ
    If UCase$(StrConv(LeftB(StrConv(Printer.DeviceName, vbFromUnicode), mylen), vbUnicode)) <> strNewPrinterName Then
      For Each objPrinter In Printers
        If StrConv(LeftB(StrConv(UCase$(objPrinter.DeviceName), vbFromUnicode), mylen), vbUnicode) = strNewPrinterName Then _
          Set Printer = objPrinter
      Next
    End If
    On Error Resume Next
    With Printer
      .Copies = DevMode.dmCopies
      .Duplex = DevMode.dmDuplex
      .Orientation = DevMode.dmOrientation
      .PaperSize = DevMode.dmPaperSize 'ϵ,ֽŴС
    End With
    On Error GoTo 0
  Else
    GlobalFree PrintDlg.hDevMode
    GlobalFree PrintDlg.hDevNames
    blnCancel = True
    If CancelError Then _
      Err.Raise cdlCancel, "LM PrintDialog", "Cancel."
  End If
  ShowPrinter = Not blnCancel
End Function


